﻿using System;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Ink;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.Collections.ObjectModel;
using Telerik.Windows.Controls;

namespace SilverlightApplication4
{
	public class MainViewModel : ViewModelBase
	{
		public ObservableCollection<TVIWrapper> TreeViewItems { get; set; }
		public bool CurrentlyFetchingData { get; set; }

		
		private bool isOptionElementsEnabled;
		public bool IsOptionElementsEnabled
		{
			get
			{
				return this.isOptionElementsEnabled;
			}
			set
			{
				if (this.isOptionElementsEnabled != value)
				{
					if (!value)
					{
						foreach (TVIWrapper item in TreeViewItems)
						{
							item.IsCheckBoxVisible = false;
							foreach (TVIWrapper child in item.Children)
							{
								child.IsCheckBoxVisible = false;
							}
						}
					}
					else
					{
						foreach (TVIWrapper item in TreeViewItems)
						{
							item.IsCheckBoxVisible = true;
							foreach (TVIWrapper child in item.Children)
							{
								child.IsCheckBoxVisible = true;
							}
						}
					}
					this.isOptionElementsEnabled = value;
					OnPropertyChanged("IsOptionElementsEnabled");
				}
			}
		}
        
		
		private TVIWrapper selectedTVI;
		/// <summary>
		///     Gets or sets the selected TVIWrapper.
		/// </summary>
		public TVIWrapper SelectedTVI
		{
			get
			{
				return this.selectedTVI;
			}
			set
			{
				if (this.selectedTVI != value)
				{
					this.selectedTVI = value;
					OnPropertyChanged("SelectedTVI");
				}
			}
		}
        

		public MainViewModel()
		{
			this.TreeViewItems = new ObservableCollection<TVIWrapper>();
			for (int i = 0; i < 6; i++)
			{
				TVIWrapper item = new TVIWrapper()
				{
					Header = String.Format("Item {0}", i),
					IsEnabled = true,
					IsExpanded = true,
					IsSelected = (i % 3) == 0,
					Type = (i % 2) == 0 ? TVIType.Building : TVIType.Divider
				};

				for (int j = 0; j < 4; j++)
				{
					item.Children.Add(new TVIWrapper()
					{
						Header = String.Format("Item {0}.{1}", i, j),
						IsEnabled = true,
						IsExpanded = false,
						IsSelected = false,
						Type = (i % 3) == 0 ? TVIType.Building : TVIType.Divider
					});
				}
				TreeViewItems.Add(item);
			}
			SelectedTVI = TreeViewItems[2];
			this.CurrentlyFetchingData = false;

		}
	}
}
